import 'dart:async';

import 'package:flutter_live_data/core.dart';
import 'package:flutter_live_data/life_cycle.dart';

/// Live Data Structure
class LiveDataBroadcast<T> extends LiveData<T> {
  LiveDataBroadcast(
    T initValue, {
    String? name,
    StreamController<T>? streamController,
    LifeCycleObserver? lifeCycleObserver,
  }) : super(
          initValue,
          name: name,
          streamController: StreamController<T>.broadcast(),
          lifeCycleObserver: lifeCycleObserver,
        );
}

extension LiveDataToBroadcast<T> on LiveData<T> {
  LiveData<T> asBroadcast() => LiveDataBroadcast(
    initialValue,
    name: name,
    lifeCycleObserver: lifeCycleObserver,
    streamController: streamController,
  );
}
